From 17fe7454df0c99ef478237b87bbafced9d7cf04a Mon Sep 17 00:00:00 2001
From: Nils Philippsen <nils@redhat.com>
Date: Dec 07 2017 16:03:58 +0000
Subject: [PATCH 4/51] execute linter methods in order of their definition


---

diff --git a/src/_fedmod/modulemd_linter.py b/src/_fedmod/modulemd_linter.py
index f29b3a0..b2c62ea 100644
--- a/src/_fedmod/modulemd_linter.py
+++ b/src/_fedmod/modulemd_linter.py
@@ -30,6 +30,8 @@ class LintLevelDecorator(object):
 
     all_levels = set()
 
+    lint_order = 0
+
     def __init__(self, level):
         assert(level not in self.all_levels)
         self.level = level
@@ -37,6 +39,8 @@ class LintLevelDecorator(object):
 
     def __call__(self, fn):
         fn.lint_level = self.level
+        fn.lint_order = LintLevelDecorator.lint_order
+        LintLevelDecorator.lint_order += 1
         return fn
 
 
@@ -70,9 +74,10 @@ class ModuleMDLinter(object):
 
         lint_method_names = [x for x in dir(self) if x.startswith("lint_")]
 
-        lint_methods = [y for y in
-                        (getattr(self, x) for x in lint_method_names)
-                        if callable(y) and y.lint_level in levels]
+        lint_methods = sorted(
+            (y for y in (getattr(self, x) for x in lint_method_names)
+             if callable(y) and y.lint_level in levels),
+            key=lambda x: x.lint_order)
 
         assert all(getattr(x, "lint_level", None)
                    in LintLevelDecorator.all_levels

